searchData={"items":[{"type":"module","title":"AI.Accumulator","doc":"When file or other input to too large for the model's context window, this\nmodule may be used to process the file in chunks. It automatically modifies\nthe supplied agent prompt to include instructions for accumulating a response\nacross multiple chunks based on the `context` (max context window tokens)\nparameter supplied by the `model` parameter.\n\nNote that while this makes use of the `AI.Completion` module, it does NOT\nhave the same interface and cannot be used for long-running conversations, as\nit does not accept a list of messages as its input.","ref":"AI.Accumulator.html"},{"type":"type","title":"AI.Accumulator.error/0","doc":"","ref":"AI.Accumulator.html#t:error/0"},{"type":"function","title":"AI.Accumulator.get_response/1","doc":"","ref":"AI.Accumulator.html#get_response/1"},{"type":"type","title":"AI.Accumulator.response/0","doc":"","ref":"AI.Accumulator.html#t:response/0"},{"type":"type","title":"AI.Accumulator.success/0","doc":"","ref":"AI.Accumulator.html#t:success/0"},{"type":"type","title":"AI.Accumulator.t/0","doc":"","ref":"AI.Accumulator.html#t:t/0"},{"type":"behaviour","title":"AI.Agent","doc":"","ref":"AI.Agent.html"},{"type":"type","title":"AI.Agent.error/0","doc":"","ref":"AI.Agent.html#t:error/0"},{"type":"callback","title":"AI.Agent.get_response/1","doc":"","ref":"AI.Agent.html#c:get_response/1"},{"type":"type","title":"AI.Agent.response/0","doc":"","ref":"AI.Agent.html#t:response/0"},{"type":"module","title":"AI.Agent.CodeMapper","doc":"","ref":"AI.Agent.CodeMapper.html"},{"type":"module","title":"AI.Agent.Coordinator","doc":"This agent uses a combination of the reasoning features of the OpenAI o3-mini\nmodel as well as its own reasoning process to research and answer the input\nquestion.\n\nIt is able to use most of the tools available and will save notes for future\nuse before finalizing its response.","ref":"AI.Agent.Coordinator.html"},{"type":"module","title":"AI.Agent.FileInfo","doc":"","ref":"AI.Agent.FileInfo.html"},{"type":"module","title":"AI.Agent.FileSummary","doc":"This module provides an agent that summarizes files' contents in order to\ngenerate embeddings for the database and summaries for the user.","ref":"AI.Agent.FileSummary.html"},{"type":"module","title":"AI.Agent.Intuition","doc":"","ref":"AI.Agent.Intuition.html"},{"type":"module","title":"AI.Agent.MOTD","doc":"","ref":"AI.Agent.MOTD.html"},{"type":"module","title":"AI.Agent.Nomenclater","doc":"","ref":"AI.Agent.Nomenclater.html"},{"type":"module","title":"AI.Agent.Nomenclater.UniqueNameThing","doc":"","ref":"AI.Agent.Nomenclater.UniqueNameThing.html"},{"type":"function","title":"AI.Agent.Nomenclater.UniqueNameThing.add_name/1","doc":"","ref":"AI.Agent.Nomenclater.UniqueNameThing.html#add_name/1"},{"type":"function","title":"AI.Agent.Nomenclater.UniqueNameThing.existing_names/0","doc":"","ref":"AI.Agent.Nomenclater.UniqueNameThing.html#existing_names/0"},{"type":"function","title":"AI.Agent.Nomenclater.UniqueNameThing.start/0","doc":"","ref":"AI.Agent.Nomenclater.UniqueNameThing.html#start/0"},{"type":"module","title":"AI.Agent.Researcher","doc":"","ref":"AI.Agent.Researcher.html"},{"type":"module","title":"AI.Agent.Spelunker","doc":"","ref":"AI.Agent.Spelunker.html"},{"type":"module","title":"AI.Completion","doc":"This module sends a request to the model and handles the response. It is able\nto handle tool calls and responses.","ref":"AI.Completion.html"},{"type":"module","title":"Input options - AI.Completion","doc":"- `toolbox` - a map of tool names to modules implementing `AI.Tools`; the specs list\n  is derived automatically via `AI.Tools.toolbox_to_specs/1`.","ref":"AI.Completion.html#module-input-options"},{"type":"module","title":"Output options - AI.Completion","doc":"Output is controlled by the following mechanisms.\n\n1. `log_msgs` - log messages from the user and assistant as `info`\n2. `log_tool_calls` - log tool calls as `info` and tool call results as `debug`\n\n`LOGGER_LEVEL` must be set to `debug` to see the output of tool call results.","ref":"AI.Completion.html#module-output-options"},{"type":"function","title":"AI.Completion.get/1","doc":"","ref":"AI.Completion.html#get/1"},{"type":"function","title":"AI.Completion.handle_tool_call/2","doc":"","ref":"AI.Completion.html#handle_tool_call/2"},{"type":"function","title":"AI.Completion.new/1","doc":"","ref":"AI.Completion.html#new/1"},{"type":"function","title":"AI.Completion.new_from_conversation/2","doc":"","ref":"AI.Completion.html#new_from_conversation/2"},{"type":"type","title":"AI.Completion.response/0","doc":"","ref":"AI.Completion.html#t:response/0"},{"type":"type","title":"AI.Completion.t/0","doc":"","ref":"AI.Completion.html#t:t/0"},{"type":"function","title":"AI.Completion.tools_used/1","doc":"","ref":"AI.Completion.html#tools_used/1"},{"type":"module","title":"AI.Completion.Output","doc":"","ref":"AI.Completion.Output.html"},{"type":"function","title":"AI.Completion.Output.log_assistant_msg/2","doc":"","ref":"AI.Completion.Output.html#log_assistant_msg/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call/2","doc":"","ref":"AI.Completion.Output.html#log_tool_call/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call/3","doc":"","ref":"AI.Completion.Output.html#log_tool_call/3"},{"type":"function","title":"AI.Completion.Output.log_tool_call_error/4","doc":"","ref":"AI.Completion.Output.html#log_tool_call_error/4"},{"type":"function","title":"AI.Completion.Output.log_tool_call_result/2","doc":"","ref":"AI.Completion.Output.html#log_tool_call_result/2"},{"type":"function","title":"AI.Completion.Output.log_tool_call_result/3","doc":"","ref":"AI.Completion.Output.html#log_tool_call_result/3"},{"type":"function","title":"AI.Completion.Output.log_user_msg/2","doc":"","ref":"AI.Completion.Output.html#log_user_msg/2"},{"type":"function","title":"AI.Completion.Output.on_event/3","doc":"","ref":"AI.Completion.Output.html#on_event/3"},{"type":"function","title":"AI.Completion.Output.replay_conversation/1","doc":"Replays an earlier conversation identically to the original interaction,\nexcept that the final response is logged as a typical assistant message, so\nthat the conversation may be continued.","ref":"AI.Completion.Output.html#replay_conversation/1"},{"type":"function","title":"AI.Completion.Output.replay_conversation_as_output/1","doc":"Replays the entire conversation, similarly to `replay_conversation/1`, but\nprints the final message to STDOUT, identically to the original interaction.\nThis is intended to be used when replaying the entire conversation to\nreplicate the original interaction, rather than for the sake of continuing\nthe conversation to refine output.","ref":"AI.Completion.Output.html#replay_conversation_as_output/1"},{"type":"module","title":"AI.CompletionAPI","doc":"","ref":"AI.CompletionAPI.html"},{"type":"function","title":"AI.CompletionAPI.get/3","doc":"","ref":"AI.CompletionAPI.html#get/3"},{"type":"type","title":"AI.CompletionAPI.model/0","doc":"","ref":"AI.CompletionAPI.html#t:model/0"},{"type":"type","title":"AI.CompletionAPI.msg_response/0","doc":"","ref":"AI.CompletionAPI.html#t:msg_response/0"},{"type":"type","title":"AI.CompletionAPI.msgs/0","doc":"","ref":"AI.CompletionAPI.html#t:msgs/0"},{"type":"type","title":"AI.CompletionAPI.response/0","doc":"","ref":"AI.CompletionAPI.html#t:response/0"},{"type":"type","title":"AI.CompletionAPI.tool_response/0","doc":"","ref":"AI.CompletionAPI.html#t:tool_response/0"},{"type":"type","title":"AI.CompletionAPI.tools/0","doc":"","ref":"AI.CompletionAPI.html#t:tools/0"},{"type":"type","title":"AI.CompletionAPI.usage/0","doc":"","ref":"AI.CompletionAPI.html#t:usage/0"},{"type":"module","title":"AI.Embeddings","doc":"","ref":"AI.Embeddings.html"},{"type":"type","title":"AI.Embeddings.attempt/0","doc":"","ref":"AI.Embeddings.html#t:attempt/0"},{"type":"type","title":"AI.Embeddings.embedding/0","doc":"","ref":"AI.Embeddings.html#t:embedding/0"},{"type":"type","title":"AI.Embeddings.embeddings/0","doc":"","ref":"AI.Embeddings.html#t:embeddings/0"},{"type":"type","title":"AI.Embeddings.error/0","doc":"","ref":"AI.Embeddings.html#t:error/0"},{"type":"function","title":"AI.Embeddings.get/1","doc":"","ref":"AI.Embeddings.html#get/1"},{"type":"type","title":"AI.Embeddings.inputs/0","doc":"","ref":"AI.Embeddings.html#t:inputs/0"},{"type":"module","title":"AI.Model","doc":"","ref":"AI.Model.html"},{"type":"function","title":"AI.Model.balanced/0","doc":"","ref":"AI.Model.html#balanced/0"},{"type":"function","title":"AI.Model.fast/0","doc":"","ref":"AI.Model.html#fast/0"},{"type":"function","title":"AI.Model.large_context/0","doc":"","ref":"AI.Model.html#large_context/0"},{"type":"function","title":"AI.Model.new/3","doc":"","ref":"AI.Model.html#new/3"},{"type":"function","title":"AI.Model.reasoning/1","doc":"","ref":"AI.Model.html#reasoning/1"},{"type":"type","title":"AI.Model.reasoning_level/0","doc":"","ref":"AI.Model.html#t:reasoning_level/0"},{"type":"function","title":"AI.Model.smart/0","doc":"","ref":"AI.Model.html#smart/0"},{"type":"type","title":"AI.Model.t/0","doc":"","ref":"AI.Model.html#t:t/0"},{"type":"module","title":"AI.Notes","doc":"Coordinates the mini-agents that manage project research notes. The workflow for this is:\n1. Initialize the notes with `init/1`, which loads existing notes from disk.\n2. Consolidate new notes from the prior research session.\n   This incorporates the new facts in the `NEW NOTES` section into the main body of the notes file.\n3. As user prompts arrive, ingest user messages with `ingest_user_msg/2`, which updates the user traits based on the user's messages.\n4. As tool calls are made, ingest research results with `ingest_research/4`, which extracts facts from the tool call results.\n5. Commit the newly gathered facts to disk with `commit/1`, which appends the new facts to the existing notes.\n   The new facts are stored in a special `NEW NOTES` section that is recognized by the consolidation agent.\n   These will be incorporated into the main notes body at the beginning of the next session.\n\nThe reason for this inverted workflow is because the consolidation process takes much longer than any of the other steps.\nBy performing it at the outset of a session, we reduce the impact of that unfortunate, abeit necessary, time delay on the user experience.","ref":"AI.Notes.html"},{"type":"function","title":"AI.Notes.ask/2","doc":"","ref":"AI.Notes.html#ask/2"},{"type":"function","title":"AI.Notes.commit/1","doc":"","ref":"AI.Notes.html#commit/1"},{"type":"function","title":"AI.Notes.consolidate/1","doc":"","ref":"AI.Notes.html#consolidate/1"},{"type":"function","title":"AI.Notes.ingest_research/4","doc":"","ref":"AI.Notes.html#ingest_research/4"},{"type":"function","title":"AI.Notes.ingest_user_msg/2","doc":"","ref":"AI.Notes.html#ingest_user_msg/2"},{"type":"function","title":"AI.Notes.init/1","doc":"","ref":"AI.Notes.html#init/1"},{"type":"function","title":"AI.Notes.new/0","doc":"","ref":"AI.Notes.html#new/0"},{"type":"type","title":"AI.Notes.t/0","doc":"","ref":"AI.Notes.html#t:t/0"},{"type":"module","title":"AI.PretendTokenizer","doc":"OpenAI's tokenizer uses regexes that are not compatible with Erlang's regex\nengine. There are a couple of modules available on hex, but all of them\nrequire a working python installation, access to rustc, a number of external\ndependencies, and some env flags set to allow it to compile.\n\nRather than impose that on end users, this module guesstimates token counts\nbased on OpenAI's assertion that 1 token is approximately 4 characters.\nCallers must take that into account when selecting their chunk size,\nincluding some amount of buffer to account for the inaccuracy of this\napproximation.","ref":"AI.PretendTokenizer.html"},{"type":"function","title":"AI.PretendTokenizer.chunk/3","doc":"","ref":"AI.PretendTokenizer.html#chunk/3"},{"type":"type","title":"AI.PretendTokenizer.chunk_size/0","doc":"","ref":"AI.PretendTokenizer.html#t:chunk_size/0"},{"type":"type","title":"AI.PretendTokenizer.chunked_input/0","doc":"","ref":"AI.PretendTokenizer.html#t:chunked_input/0"},{"type":"function","title":"AI.PretendTokenizer.guesstimate_tokens/1","doc":"","ref":"AI.PretendTokenizer.html#guesstimate_tokens/1"},{"type":"type","title":"AI.PretendTokenizer.input/0","doc":"","ref":"AI.PretendTokenizer.html#t:input/0"},{"type":"function","title":"AI.PretendTokenizer.over_max_for_openai_embeddings?/1","doc":"","ref":"AI.PretendTokenizer.html#over_max_for_openai_embeddings?/1"},{"type":"type","title":"AI.PretendTokenizer.reduction_factor/0","doc":"","ref":"AI.PretendTokenizer.html#t:reduction_factor/0"},{"type":"module","title":"AI.Splitter","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","ref":"AI.Splitter.html"},{"type":"function","title":"AI.Splitter.new/2","doc":"","ref":"AI.Splitter.html#new/2"},{"type":"function","title":"AI.Splitter.next_chunk/2","doc":"","ref":"AI.Splitter.html#next_chunk/2"},{"type":"type","title":"AI.Splitter.t/0","doc":"","ref":"AI.Splitter.html#t:t/0"},{"type":"behaviour","title":"AI.Tools","doc":"This module defines the behaviour for tool calls. Defining a new tool\nrequires implementing the `spec/0` and `call/2` functions.\n\nThe `spec/0` function should return a map that describes the tool's\ncapabilities and arguments, using a map to represent the OpenAPI spec.\n\nThe `call/2` function generates the tool call response. It accepts the\nrequesting `AI.Completion`'s struct and a map derived from the parsed JSON\nprovided by the agent, containing the tool call arguments. Note that, because\nthe arguments are parsed from JSON, the keys will all be strings. Whether\nthose are converted to symbols is between the tool implementation and the\ncode it calls. What happens behind closed APIs is none of MY business.","ref":"AI.Tools.html"},{"type":"behaviour","title":"Skeleton Implementation - AI.Tools","doc":"```elixir\ndefmodule AI.Tools.MyNewTool do\n  @behaviour AI.Tools\n\n  @impl AI.Tools\n  def async?(), do: true\n\n  @impl AI.Tools\n  def ui_note_on_request(_args) do\n    {\"Doing something\", \"This tool is doing something.\"}\n  end\n\n  @impl AI.Tools\n  def ui_note_on_result(_args, _result) do\n    {\"Did something\", \"This tool did something.\"}\n  end\n\n  @impl AI.Tools\n  def read_args(args) do\n    {:ok, args}\n  end\n\n  @impl AI.Tools\n  def spec() do\n    %{\n      type: \"function\",\n      function: %{\n        name: \"something_tool\",\n        description: \"This tool does something.\",\n        strict: true,\n        parameters: %{\n          additionalProperties: false,\n          type: \"object\",\n          required: [\"thing\"],\n          properties: %{\n            thing: %{\n              type: \"string\",\n              description: \"The thing to do.\"\n            }\n          }\n        }\n      }\n    }\n  end\n\n  @impl AI.Tools\n  def call(args) do\n    {:ok, \"IMPLEMENT ME\"}\n  end\nend\n```","ref":"AI.Tools.html#module-skeleton-implementation"},{"type":"function","title":"AI.Tools.all_tools/0","doc":"","ref":"AI.Tools.html#all_tools/0"},{"type":"type","title":"AI.Tools.args_error/0","doc":"","ref":"AI.Tools.html#t:args_error/0"},{"type":"callback","title":"AI.Tools.async?/0","doc":"Returns true if the tool is asynchronous, false otherwise. If `false`, when\nthe LLM performs a multi-tool call, this tool will be called synchronously,\nafter all other (asynchronous) tools have been called.","ref":"AI.Tools.html#c:async?/0"},{"type":"function","title":"AI.Tools.build_toolbox/1","doc":"Given a list of modules, returns a map from tool_name => module, using each\nmodule's spec().function.name value as the key.","ref":"AI.Tools.html#build_toolbox/1"},{"type":"callback","title":"AI.Tools.call/1","doc":"Calls the tool with the provided arguments and returns the response as an :ok\ntuple.","ref":"AI.Tools.html#c:call/1"},{"type":"type","title":"AI.Tools.entry/0","doc":"","ref":"AI.Tools.html#t:entry/0"},{"type":"type","title":"AI.Tools.entry_not_found/0","doc":"","ref":"AI.Tools.html#t:entry_not_found/0"},{"type":"type","title":"AI.Tools.frob_error/0","doc":"","ref":"AI.Tools.html#t:frob_error/0"},{"type":"function","title":"AI.Tools.get_arg/3","doc":"Retrieves an argument from the parsed arguments map. If `allow_empty?` is\n`true` (default: `false`), an empty string or `nil` value is considered valid\nand will return `{:ok, value}`. If `allow_empty?` is `false`, an empty string\nor `nil` will return an error indicating a missing argument.","ref":"AI.Tools.html#get_arg/3"},{"type":"function","title":"AI.Tools.get_entry/1","doc":"","ref":"AI.Tools.html#get_entry/1"},{"type":"function","title":"AI.Tools.get_entry/2","doc":"","ref":"AI.Tools.html#get_entry/2"},{"type":"function","title":"AI.Tools.get_file_contents/1","doc":"","ref":"AI.Tools.html#get_file_contents/1"},{"type":"function","title":"AI.Tools.get_project/0","doc":"","ref":"AI.Tools.html#get_project/0"},{"type":"function","title":"AI.Tools.has_indexed_project/0","doc":"","ref":"AI.Tools.html#has_indexed_project/0"},{"type":"type","title":"AI.Tools.invalid_arg_error/0","doc":"","ref":"AI.Tools.html#t:invalid_arg_error/0"},{"type":"function","title":"AI.Tools.is_async?/2","doc":"","ref":"AI.Tools.html#is_async?/2"},{"type":"callback","title":"AI.Tools.is_available?/0","doc":"Returns true if the tool is available for use, false otherwise. This is used\nto determine whether the tool can be used in the current context, such as\nwhether the tool is available in the current project or if it requires\nspecific conditions to be met (e.g., a project being set, availability of an\nexternal tool like ripgrep, etc.).","ref":"AI.Tools.html#c:is_available?/0"},{"type":"type","title":"AI.Tools.json_parse_error/0","doc":"","ref":"AI.Tools.html#t:json_parse_error/0"},{"type":"type","title":"AI.Tools.missing_arg_error/0","doc":"","ref":"AI.Tools.html#t:missing_arg_error/0"},{"type":"function","title":"AI.Tools.on_tool_request/3","doc":"","ref":"AI.Tools.html#on_tool_request/3"},{"type":"function","title":"AI.Tools.on_tool_result/4","doc":"","ref":"AI.Tools.html#on_tool_result/4"},{"type":"type","title":"AI.Tools.parsed_args/0","doc":"","ref":"AI.Tools.html#t:parsed_args/0"},{"type":"function","title":"AI.Tools.perform_tool_call/3","doc":"","ref":"AI.Tools.html#perform_tool_call/3"},{"type":"type","title":"AI.Tools.project/0","doc":"","ref":"AI.Tools.html#t:project/0"},{"type":"type","title":"AI.Tools.project_name/0","doc":"","ref":"AI.Tools.html#t:project_name/0"},{"type":"type","title":"AI.Tools.project_not_found/0","doc":"","ref":"AI.Tools.html#t:project_not_found/0"},{"type":"type","title":"AI.Tools.raw_tool_result/0","doc":"","ref":"AI.Tools.html#t:raw_tool_result/0"},{"type":"callback","title":"AI.Tools.read_args/1","doc":"Reads the arguments and returns a map of the arguments if they are valid.\nThis is used to validate args before the tool is called. The result is what\nis passed to `call/2`, `ui_note_on_request/1`, and `ui_note_on_result/2`.","ref":"AI.Tools.html#c:read_args/1"},{"type":"function","title":"AI.Tools.required_arg_error/1","doc":"","ref":"AI.Tools.html#required_arg_error/1"},{"type":"type","title":"AI.Tools.something_not_found/0","doc":"","ref":"AI.Tools.html#t:something_not_found/0"},{"type":"callback","title":"AI.Tools.spec/0","doc":"Returns the OpenAPI spec for the tool as an elixir map.","ref":"AI.Tools.html#c:spec/0"},{"type":"type","title":"AI.Tools.tool_error/0","doc":"","ref":"AI.Tools.html#t:tool_error/0"},{"type":"function","title":"AI.Tools.tool_module/2","doc":"","ref":"AI.Tools.html#tool_module/2"},{"type":"type","title":"AI.Tools.tool_name/0","doc":"","ref":"AI.Tools.html#t:tool_name/0"},{"type":"type","title":"AI.Tools.tool_result/0","doc":"","ref":"AI.Tools.html#t:tool_result/0"},{"type":"type","title":"AI.Tools.tool_spec/0","doc":"","ref":"AI.Tools.html#t:tool_spec/0"},{"type":"function","title":"AI.Tools.tool_spec/2","doc":"","ref":"AI.Tools.html#tool_spec/2"},{"type":"function","title":"AI.Tools.tool_spec!/2","doc":"","ref":"AI.Tools.html#tool_spec!/2"},{"type":"type","title":"AI.Tools.toolbox/0","doc":"","ref":"AI.Tools.html#t:toolbox/0"},{"type":"function","title":"AI.Tools.toolbox_to_specs/1","doc":"Generate a list of tool specs from a toolbox map.","ref":"AI.Tools.html#toolbox_to_specs/1"},{"type":"function","title":"AI.Tools.tools/0","doc":"","ref":"AI.Tools.html#tools/0"},{"type":"callback","title":"AI.Tools.ui_note_on_request/1","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool is called.","ref":"AI.Tools.html#c:ui_note_on_request/1"},{"type":"callback","title":"AI.Tools.ui_note_on_result/2","doc":"Return either a short string or a string tuple of label + detail to be\ndisplayed when the tool call is successful.","ref":"AI.Tools.html#c:ui_note_on_result/2"},{"type":"type","title":"AI.Tools.unknown_tool_error/0","doc":"","ref":"AI.Tools.html#t:unknown_tool_error/0"},{"type":"type","title":"AI.Tools.unparsed_args/0","doc":"","ref":"AI.Tools.html#t:unparsed_args/0"},{"type":"function","title":"AI.Tools.validate_required_args/3","doc":"","ref":"AI.Tools.html#validate_required_args/3"},{"type":"function","title":"AI.Tools.with_args/4","doc":"","ref":"AI.Tools.html#with_args/4"},{"type":"module","title":"AI.Tools.Coder","doc":"","ref":"AI.Tools.Coder.html"},{"type":"function","title":"AI.Tools.Coder.async?/0","doc":"This tool relies on line numbers within the file to identify ranges. If those\nnumbers change between the time the range is identified and the time the\nchanges are applied, the tool will fail to apply the changes correctly.","ref":"AI.Tools.Coder.html#async?/0"},{"type":"module","title":"AI.Tools.Confirm","doc":"","ref":"AI.Tools.Confirm.html"},{"type":"function","title":"AI.Tools.Confirm.async?/0","doc":"This tool interacts with the user. Executing it concurrently could result in\nmultiple messages appearing in the terminal together before the user has a\nchance to respond, with multiple stacked readlines waiting for input.\nInstead, we execute them synchronously, to ensure we get an answer for one\nbefore the next is displayed.","ref":"AI.Tools.Confirm.html#async?/0"},{"type":"module","title":"AI.Tools.File.Contents","doc":"","ref":"AI.Tools.File.Contents.html"},{"type":"module","title":"AI.Tools.File.Edit","doc":"Currently, this module is not used as a tool_call directly. Instead, it is\nused by `AI.Tools.Coder`, the tool directly called by the AI agent. This tool\nis instead used to perform the file edits themselves, after the AI-backed\ntool does the work of identifying the lines to edit and the replacement text.","ref":"AI.Tools.File.Edit.html"},{"type":"function","title":"AI.Tools.File.Edit.async?/0","doc":"This tool relies on line numbers within the file to identify ranges. If those\nnumbers change between the time the range is identified and the time the\nchanges are applied, the tool will fail to apply the changes correctly.","ref":"AI.Tools.File.Edit.html#async?/0"},{"type":"module","title":"AI.Tools.File.Info","doc":"","ref":"AI.Tools.File.Info.html"},{"type":"module","title":"AI.Tools.File.List","doc":"","ref":"AI.Tools.File.List.html"},{"type":"module","title":"AI.Tools.File.Manage","doc":"","ref":"AI.Tools.File.Manage.html"},{"type":"module","title":"AI.Tools.File.Outline","doc":"","ref":"AI.Tools.File.Outline.html"},{"type":"module","title":"AI.Tools.File.Reindex","doc":"","ref":"AI.Tools.File.Reindex.html"},{"type":"module","title":"AI.Tools.File.Search","doc":"","ref":"AI.Tools.File.Search.html"},{"type":"function","title":"AI.Tools.File.Search.is_available?/0","doc":"This tool requires that the project has been indexed to use. If the project\nhas not been indexed, the tool should not be made available.","ref":"AI.Tools.File.Search.html#is_available?/0"},{"type":"module","title":"AI.Tools.File.Spelunker","doc":"","ref":"AI.Tools.File.Spelunker.html"},{"type":"module","title":"AI.Tools.Git.DiffBranch","doc":"","ref":"AI.Tools.Git.DiffBranch.html"},{"type":"module","title":"AI.Tools.Git.Grep","doc":"","ref":"AI.Tools.Git.Grep.html"},{"type":"module","title":"AI.Tools.Git.ListBranches","doc":"","ref":"AI.Tools.Git.ListBranches.html"},{"type":"module","title":"AI.Tools.Git.Log","doc":"","ref":"AI.Tools.Git.Log.html"},{"type":"module","title":"AI.Tools.Git.Pickaxe","doc":"","ref":"AI.Tools.Git.Pickaxe.html"},{"type":"module","title":"AI.Tools.Git.Show","doc":"","ref":"AI.Tools.Git.Show.html"},{"type":"module","title":"AI.Tools.Git.UnstagedChanges","doc":"","ref":"AI.Tools.Git.UnstagedChanges.html"},{"type":"module","title":"AI.Tools.Notes","doc":"","ref":"AI.Tools.Notes.html"},{"type":"module","title":"AI.Tools.Research","doc":"","ref":"AI.Tools.Research.html"},{"type":"module","title":"AI.Tools.Ripgrep","doc":"","ref":"AI.Tools.Ripgrep.html"},{"type":"module","title":"AI.Util","doc":"","ref":"AI.Util.html"},{"type":"function","title":"AI.Util.assistant_msg/1","doc":"Creates an assistant message object, representing the assistant's response.","ref":"AI.Util.html#assistant_msg/1"},{"type":"function","title":"AI.Util.assistant_tool_msg/3","doc":"This is the tool call message, which must come immediately before the\n`tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#assistant_tool_msg/3"},{"type":"function","title":"AI.Util.cosine_similarity/2","doc":"","ref":"AI.Util.html#cosine_similarity/2"},{"type":"function","title":"AI.Util.research_transcript/1","doc":"Builds a \"transcript\" of the research process by converting the messages into\ntext. This is most commonly used to generate a transcript of the research\nperformed in a conversation for various agents and tool calls.","ref":"AI.Util.html#research_transcript/1"},{"type":"function","title":"AI.Util.system_msg/1","doc":"Creates a system message object, used to define the assistant's behavior for\nthe conversation.","ref":"AI.Util.html#system_msg/1"},{"type":"function","title":"AI.Util.tool_msg/3","doc":"This is the tool outputs message, which must come immediately after the\n`assistant_tool_msg/3` message with the same `tool_call_id` (`id`).","ref":"AI.Util.html#tool_msg/3"},{"type":"function","title":"AI.Util.user_msg/1","doc":"Creates a user message object, representing the user's input prompt.","ref":"AI.Util.html#user_msg/1"},{"type":"function","title":"AI.Util.user_query/1","doc":"Extracts the user's *most recent* query from the conversation messages.","ref":"AI.Util.html#user_query/1"},{"type":"behaviour","title":"Cmd","doc":"","ref":"Cmd.html"},{"type":"function","title":"Cmd.default_workers/0","doc":"","ref":"Cmd.html#default_workers/0"},{"type":"function","title":"Cmd.perform_command/4","doc":"","ref":"Cmd.html#perform_command/4"},{"type":"function","title":"Cmd.project_arg/0","doc":"","ref":"Cmd.html#project_arg/0"},{"type":"callback","title":"Cmd.requires_project?/0","doc":"","ref":"Cmd.html#c:requires_project?/0"},{"type":"callback","title":"Cmd.run/3","doc":"","ref":"Cmd.html#c:run/3"},{"type":"callback","title":"Cmd.spec/0","doc":"","ref":"Cmd.html#c:spec/0"},{"type":"function","title":"Cmd.workers_arg/0","doc":"","ref":"Cmd.html#workers_arg/0"},{"type":"module","title":"Cmd.Ask","doc":"","ref":"Cmd.Ask.html"},{"type":"module","title":"Cmd.Config","doc":"","ref":"Cmd.Config.html"},{"type":"module","title":"Cmd.Conversations","doc":"","ref":"Cmd.Conversations.html"},{"type":"module","title":"Cmd.Files","doc":"","ref":"Cmd.Files.html"},{"type":"module","title":"Cmd.Frobs","doc":"","ref":"Cmd.Frobs.html"},{"type":"module","title":"Cmd.Index","doc":"","ref":"Cmd.Index.html"},{"type":"function","title":"Cmd.Index.index_project/1","doc":"","ref":"Cmd.Index.html#index_project/1"},{"type":"function","title":"Cmd.Index.new/1","doc":"","ref":"Cmd.Index.html#new/1"},{"type":"function","title":"Cmd.Index.perform_task/1","doc":"","ref":"Cmd.Index.html#perform_task/1"},{"type":"type","title":"Cmd.Index.t/0","doc":"","ref":"Cmd.Index.html#t:t/0"},{"type":"module","title":"Cmd.Notes","doc":"","ref":"Cmd.Notes.html"},{"type":"module","title":"Cmd.Prime","doc":"","ref":"Cmd.Prime.html"},{"type":"module","title":"Cmd.Projects","doc":"","ref":"Cmd.Projects.html"},{"type":"module","title":"Cmd.Replay","doc":"","ref":"Cmd.Replay.html"},{"type":"module","title":"Cmd.Search","doc":"","ref":"Cmd.Search.html"},{"type":"module","title":"Cmd.Summary","doc":"","ref":"Cmd.Summary.html"},{"type":"module","title":"Cmd.Tool","doc":"","ref":"Cmd.Tool.html"},{"type":"module","title":"Cmd.Torch","doc":"","ref":"Cmd.Torch.html"},{"type":"function","title":"Cmd.Torch.run/3","doc":"Permanently deletes the project from the store.","ref":"Cmd.Torch.html#run/3"},{"type":"module","title":"Cmd.Upgrade","doc":"","ref":"Cmd.Upgrade.html"},{"type":"module","title":"Fnord","doc":"Fnord is a code search tool that uses OpenAI's embeddings API to index and\nsearch code files.","ref":"Fnord.html"},{"type":"function","title":"Fnord.configure_logger/0","doc":"","ref":"Fnord.html#configure_logger/0"},{"type":"function","title":"Fnord.main/1","doc":"Main entry point for the application. Parses command line arguments and\ndispatches to the appropriate subcommand.","ref":"Fnord.html#main/1"},{"type":"function","title":"Fnord.spec/0","doc":"","ref":"Fnord.html#spec/0"},{"type":"module","title":"Frobs","doc":"Frobs are external tool call integrations. They allow users to define\nexternal actions that can be executed by the LLM while researching the user's\nquery.\n\nFrobs are stored in `$HOME/.fnord/tools/$frob_name` and are composed of:\n- `registry.json`:  A JSON file that registers the frob for the user's projects\n- `spec.json`:      A JSON file that defines the tool call's calling semantics\n- `main`:           A script or binary that performs the action\n- `available`:      A script or binary that exits non-zero if the frob is not\n                    available in the current context (e.g. dependencies,\n                    environment, etc.)\n\nThe `registry.json` file contains the following fields:\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\"\n  // field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob\n  // available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"my_project\", \"other_project\"]\n}\n```\n\nThe \"name\" field in `spec.json` is used to register the frob with the LLM.\nThis name must match the frob's directory name.\n\nIf desired, the user can add a lib/util/etc directory to hold any utility or\nhelper code to be used by `main`.\n\nFnord communicates run-time information to the frob via environment variables:\n- FNORD_PROJECT     # The name of the currently selected project\n- FNORD_CONFIG      # JSON object of project config\n- FNORD_ARGS_JSON   # JSON object of LLM-provided arguments","ref":"Frobs.html"},{"type":"function","title":"Frobs.create/1","doc":"","ref":"Frobs.html#create/1"},{"type":"function","title":"Frobs.create_tool_module/1","doc":"","ref":"Frobs.html#create_tool_module/1"},{"type":"function","title":"Frobs.create_tool_module/2","doc":"","ref":"Frobs.html#create_tool_module/2"},{"type":"function","title":"Frobs.is_available?/1","doc":"","ref":"Frobs.html#is_available?/1"},{"type":"function","title":"Frobs.is_registered?/1","doc":"","ref":"Frobs.html#is_registered?/1"},{"type":"function","title":"Frobs.list/0","doc":"","ref":"Frobs.html#list/0"},{"type":"function","title":"Frobs.load/1","doc":"","ref":"Frobs.html#load/1"},{"type":"function","title":"Frobs.module_map/0","doc":"","ref":"Frobs.html#module_map/0"},{"type":"function","title":"Frobs.perform_tool_call/2","doc":"","ref":"Frobs.html#perform_tool_call/2"},{"type":"type","title":"Frobs.t/0","doc":"","ref":"Frobs.html#t:t/0"},{"type":"module","title":"Git","doc":"Module for interacting with git.","ref":"Git.html"},{"type":"function","title":"Git.base_commit/2","doc":"","ref":"Git.html#base_commit/2"},{"type":"function","title":"Git.current_branch/0","doc":"","ref":"Git.html#current_branch/0"},{"type":"function","title":"Git.diff_branch/2","doc":"","ref":"Git.html#diff_branch/2"},{"type":"function","title":"Git.git_diff/1","doc":"","ref":"Git.html#git_diff/1"},{"type":"function","title":"Git.git_log/1","doc":"","ref":"Git.html#git_log/1"},{"type":"function","title":"Git.git_root/0","doc":"","ref":"Git.html#git_root/0"},{"type":"function","title":"Git.grep/2","doc":"","ref":"Git.html#grep/2"},{"type":"function","title":"Git.ignored_dirs/0","doc":"","ref":"Git.html#ignored_dirs/0"},{"type":"function","title":"Git.ignored_dirs/1","doc":"","ref":"Git.html#ignored_dirs/1"},{"type":"function","title":"Git.ignored_files/0","doc":"","ref":"Git.html#ignored_files/0"},{"type":"function","title":"Git.ignored_files/1","doc":"","ref":"Git.html#ignored_files/1"},{"type":"function","title":"Git.is_available?/0","doc":"","ref":"Git.html#is_available?/0"},{"type":"function","title":"Git.is_git_repo?/0","doc":"","ref":"Git.html#is_git_repo?/0"},{"type":"function","title":"Git.is_git_repo?/1","doc":"","ref":"Git.html#is_git_repo?/1"},{"type":"function","title":"Git.is_ignored?/1","doc":"","ref":"Git.html#is_ignored?/1"},{"type":"function","title":"Git.is_ignored?/2","doc":"","ref":"Git.html#is_ignored?/2"},{"type":"function","title":"Git.list_branches/0","doc":"","ref":"Git.html#list_branches/0"},{"type":"function","title":"Git.pickaxe_regex/1","doc":"","ref":"Git.html#pickaxe_regex/1"},{"type":"function","title":"Git.show/1","doc":"","ref":"Git.html#show/1"},{"type":"function","title":"Git.show/2","doc":"","ref":"Git.html#show/2"},{"type":"module","title":"Http","doc":"","ref":"Http.html"},{"type":"type","title":"Http.headers/0","doc":"","ref":"Http.html#t:headers/0"},{"type":"type","title":"Http.http_error/0","doc":"","ref":"Http.html#t:http_error/0"},{"type":"type","title":"Http.http_status/0","doc":"","ref":"Http.html#t:http_status/0"},{"type":"type","title":"Http.options/0","doc":"","ref":"Http.html#t:options/0"},{"type":"type","title":"Http.payload/0","doc":"","ref":"Http.html#t:payload/0"},{"type":"function","title":"Http.post_json/3","doc":"Sends a POST request with a JSON payload to the specified URL with the given\nheaders. Returns a tuple with the response status and body, or an error if\nthe request fails.","ref":"Http.html#post_json/3"},{"type":"type","title":"Http.response/0","doc":"","ref":"Http.html#t:response/0"},{"type":"type","title":"Http.success/0","doc":"","ref":"Http.html#t:success/0"},{"type":"type","title":"Http.transport_error/0","doc":"","ref":"Http.html#t:transport_error/0"},{"type":"type","title":"Http.url/0","doc":"","ref":"Http.html#t:url/0"},{"type":"behaviour","title":"Indexer","doc":"This behaviour wraps the AI-powered operations used by `Cmd.Index` to allow\noverrides for testing. See `impl/0`.","ref":"Indexer.html"},{"type":"type","title":"Indexer.completion/0","doc":"","ref":"Indexer.html#t:completion/0"},{"type":"type","title":"Indexer.embeddings/0","doc":"","ref":"Indexer.html#t:embeddings/0"},{"type":"type","title":"Indexer.error/0","doc":"","ref":"Indexer.html#t:error/0"},{"type":"type","title":"Indexer.file_content/0","doc":"","ref":"Indexer.html#t:file_content/0"},{"type":"type","title":"Indexer.file_path/0","doc":"","ref":"Indexer.html#t:file_path/0"},{"type":"callback","title":"Indexer.get_embeddings/1","doc":"","ref":"Indexer.html#c:get_embeddings/1"},{"type":"callback","title":"Indexer.get_outline/2","doc":"","ref":"Indexer.html#c:get_outline/2"},{"type":"callback","title":"Indexer.get_summary/2","doc":"","ref":"Indexer.html#c:get_summary/2"},{"type":"function","title":"Indexer.impl/0","doc":"Returns the current indexer module. This can be overridden by config for unit\ntesting. See `test/test_helper.exs`.","ref":"Indexer.html#impl/0"},{"type":"type","title":"Indexer.indexer/0","doc":"","ref":"Indexer.html#t:indexer/0"},{"type":"module","title":"NotesServer","doc":"","ref":"NotesServer.html"},{"type":"function","title":"NotesServer.ask/1","doc":"Uses an AI model to answer a question about the existing research notes. The\nquestion should be a concise request for information about the project, such\nas \"What is the purpose of this project?\" or \"What languages and technologies\nare used in this project?\". The AI model will analyze the existing notes and\nreturn a concise answer.","ref":"NotesServer.html#ask/1"},{"type":"function","title":"NotesServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NotesServer.html#child_spec/1"},{"type":"function","title":"NotesServer.commit/0","doc":"Commits the new notes that have been collected over the course of the current\nsession to persistent storage. This saves any newly extracted facts and user\ninsights that have not yet been consolidated into the main research notes.\n\nThe new notes are added to a special section at the end of the existing\nresearch notes, labeled `# NEW NOTES (unconsolidated)`. This section is meant\nto be consolidated later by the `consolidate/0` function.","ref":"NotesServer.html#commit/0"},{"type":"function","title":"NotesServer.consolidate/0","doc":"Consolidates all newly extracted facts and user insights into the existing\nresearch notes. This uses an AI model to reorganize and consolidate the notes\naccording to specified guidelines. The consolidated notes are saved to\npersistent storage.\n\nCurrently, consolidation generally happens at the beginning of a new research\nsession (from `AI.Agent.Coordinator`).","ref":"NotesServer.html#consolidate/0"},{"type":"function","title":"NotesServer.ingest_research/3","doc":"Uses an AI model to analyze the result of a tool call and extract facts about\nthe project. The facts are stored in the server's state and can be\nconsolidated later.","ref":"NotesServer.html#ingest_research/3"},{"type":"function","title":"NotesServer.ingest_user_msg/1","doc":"Uses an AI model to analyze the user's message and extract insights about\ntheir coding preferences, learning style, personality, and other relevant\ntraits. The insights are stored in the server's state and can be consolidated\nlater.","ref":"NotesServer.html#ingest_user_msg/1"},{"type":"function","title":"NotesServer.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"NotesServer.html#init/1"},{"type":"function","title":"NotesServer.load_notes/0","doc":"Load existing research notes from persistent storage. The project must be set\nfrom the --project command line option or CWD.","ref":"NotesServer.html#load_notes/0"},{"type":"function","title":"NotesServer.start_link/1","doc":"","ref":"NotesServer.html#start_link/1"},{"type":"module","title":"Once","doc":"This module provides a mechanism to perform actions only once, using a unique\nkey provided by the caller to determine whether the action has already been\nperformed this session.","ref":"Once.html"},{"type":"function","title":"Once.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Once.html#child_spec/1"},{"type":"function","title":"Once.get/1","doc":"Checks if a key has been seen before. If the key has not been seen, it\nreturns `{:error, :not_seen}`. If the key has been seen, it returns `{:ok,\nvalue}` where `value` is the value associated with the key, or `true` if no\nvalue was specified.","ref":"Once.html#get/1"},{"type":"function","title":"Once.set/2","doc":"Marks a key as seen. If the key has not been seen before, it returns `true`\nand updates the internal state. If the key has already been seen, it returns\n`false` without updating the state.","ref":"Once.html#set/2"},{"type":"function","title":"Once.start_link/1","doc":"Starts the agent that keeps track of seen keys.","ref":"Once.html#start_link/1"},{"type":"function","title":"Once.warn/1","doc":"Emits a warning (using `UI.warn/1`) if the message has not yet been emitted\nduring this session.","ref":"Once.html#warn/1"},{"type":"module","title":"Search","doc":"","ref":"Search.html"},{"type":"function","title":"Search.get_results/1","doc":"","ref":"Search.html#get_results/1"},{"type":"function","title":"Search.new/1","doc":"","ref":"Search.html#new/1"},{"type":"module","title":"Settings","doc":"","ref":"Settings.html"},{"type":"function","title":"Settings.delete/2","doc":"Delete a value from the settings store.","ref":"Settings.html#delete/2"},{"type":"function","title":"Settings.get/3","doc":"Get a value from the settings store.","ref":"Settings.html#get/3"},{"type":"function","title":"Settings.get_project/1","doc":"","ref":"Settings.html#get_project/1"},{"type":"function","title":"Settings.get_root/1","doc":"","ref":"Settings.html#get_root/1"},{"type":"function","title":"Settings.get_selected_project/0","doc":"Get the project specified with --project. If the project name is not set, an\nerror tuple is returned.","ref":"Settings.html#get_selected_project/0"},{"type":"function","title":"Settings.home/0","doc":"Get the path to the store root directory.","ref":"Settings.html#home/0"},{"type":"function","title":"Settings.list_projects/1","doc":"","ref":"Settings.html#list_projects/1"},{"type":"function","title":"Settings.new/0","doc":"","ref":"Settings.html#new/0"},{"type":"function","title":"Settings.project_is_set?/0","doc":"Check if the --project option is set.","ref":"Settings.html#project_is_set?/0"},{"type":"function","title":"Settings.set/3","doc":"Set a value in the settings store.","ref":"Settings.html#set/3"},{"type":"function","title":"Settings.set_project/1","doc":"Set the project name for the --project option.","ref":"Settings.html#set_project/1"},{"type":"function","title":"Settings.set_project/2","doc":"","ref":"Settings.html#set_project/2"},{"type":"function","title":"Settings.settings_file/0","doc":"Get the path to the settings file. If the file does not exist, it will be\ncreated.","ref":"Settings.html#settings_file/0"},{"type":"type","title":"Settings.t/0","doc":"","ref":"Settings.html#t:t/0"},{"type":"module","title":"Spinner","doc":"","ref":"Spinner.html"},{"type":"function","title":"Spinner.run/2","doc":"","ref":"Spinner.html#run/2"},{"type":"module","title":"Store","doc":"","ref":"Store.html"},{"type":"function","title":"Store.get_project/0","doc":"Retrieves the currently selected project (specified with `--project` or via\ncwd) as a `Store.Project.t`. If unset, returns `{:error, :project_not_set}`.","ref":"Store.html#get_project/0"},{"type":"function","title":"Store.get_project/1","doc":"Returns an ok tuple with a `Store.Project.t`, identified either by name or by\nsimply passing through a `Store.Project.t` instance. If passed nil, it\nattempts to use the currently selected project (specified with `--project` or\nvia cwd).","ref":"Store.html#get_project/1"},{"type":"function","title":"Store.store_home/0","doc":"","ref":"Store.html#store_home/0"},{"type":"module","title":"Store.Project","doc":"","ref":"Store.Project.html"},{"type":"function","title":"Store.Project.conversations/1","doc":"","ref":"Store.Project.html#conversations/1"},{"type":"function","title":"Store.Project.create/1","doc":"","ref":"Store.Project.html#create/1"},{"type":"function","title":"Store.Project.delete/1","doc":"","ref":"Store.Project.html#delete/1"},{"type":"function","title":"Store.Project.delete_missing_files/1","doc":"","ref":"Store.Project.html#delete_missing_files/1"},{"type":"function","title":"Store.Project.exists_in_store?/1","doc":"","ref":"Store.Project.html#exists_in_store?/1"},{"type":"function","title":"Store.Project.expand_path/2","doc":"","ref":"Store.Project.html#expand_path/2"},{"type":"function","title":"Store.Project.find_entry/2","doc":"","ref":"Store.Project.html#find_entry/2"},{"type":"function","title":"Store.Project.find_file/2","doc":"Resolves `path` within the project's source root. Returns `{:ok, path}` if the file exists,\nor `{:error, :enoent}` if it does not.","ref":"Store.Project.html#find_file/2"},{"type":"function","title":"Store.Project.find_path_in_source_root/2","doc":"","ref":"Store.Project.html#find_path_in_source_root/2"},{"type":"function","title":"Store.Project.has_index?/1","doc":"","ref":"Store.Project.html#has_index?/1"},{"type":"type","title":"Store.Project.index_status/0","doc":"","ref":"Store.Project.html#t:index_status/0"},{"type":"function","title":"Store.Project.index_status/1","doc":"Returns the status of the index for the given project.\n\nIt classifies entries into:\n  * `:deleted`  - entries that were indexed but the source files have been removed\n  * `:stale`    - entries whose indexed metadata is stale compared to the source file\n  * `:new`      - entries for unindexed files that exist in the source","ref":"Store.Project.html#index_status/1"},{"type":"function","title":"Store.Project.make_default_for_session/1","doc":"","ref":"Store.Project.html#make_default_for_session/1"},{"type":"function","title":"Store.Project.new/2","doc":"","ref":"Store.Project.html#new/2"},{"type":"function","title":"Store.Project.relative_path/2","doc":"","ref":"Store.Project.html#relative_path/2"},{"type":"function","title":"Store.Project.save_settings/3","doc":"","ref":"Store.Project.html#save_settings/3"},{"type":"function","title":"Store.Project.source_files/1","doc":"","ref":"Store.Project.html#source_files/1"},{"type":"function","title":"Store.Project.stored_files/1","doc":"","ref":"Store.Project.html#stored_files/1"},{"type":"type","title":"Store.Project.t/0","doc":"","ref":"Store.Project.html#t:t/0"},{"type":"function","title":"Store.Project.torch/1","doc":"","ref":"Store.Project.html#torch/1"},{"type":"module","title":"Store.Project.Conversation","doc":"Conversations are stored per project in the project's store dir, under\n`converations/`. Each conversation is given a UUID identifier and stored as a\nJSON file with the keys:\n  - `messages`: a list of messages in the conversation\n  - `timestamp`: the time the conversation was last written to\n\nExisting conversations are retrieved by their UUID identifier.","ref":"Store.Project.Conversation.html"},{"type":"function","title":"Store.Project.Conversation.delete/1","doc":"Deletes the conversation from the store. If the conversation does not exist,\nreturns an error tuple.","ref":"Store.Project.Conversation.html#delete/1"},{"type":"function","title":"Store.Project.Conversation.exists?/1","doc":"Returns true if the conversation exists on disk, false otherwise.","ref":"Store.Project.Conversation.html#exists?/1"},{"type":"function","title":"Store.Project.Conversation.list/1","doc":"Lists all conversations in the given project in ascending order by timestamp.","ref":"Store.Project.Conversation.html#list/1"},{"type":"function","title":"Store.Project.Conversation.new/0","doc":"Create a new conversation with a new UUID identifier and the globally\nselected project.","ref":"Store.Project.Conversation.html#new/0"},{"type":"function","title":"Store.Project.Conversation.new/1","doc":"Create a new conversation from an existing UUID identifier and the globally\nselected project.","ref":"Store.Project.Conversation.html#new/1"},{"type":"function","title":"Store.Project.Conversation.new/2","doc":"Create a new conversation from an existing UUID identifier and an explicitly\nspecified project.","ref":"Store.Project.Conversation.html#new/2"},{"type":"function","title":"Store.Project.Conversation.question/1","doc":"Returns the user's prompting message in the conversation. This is considered\nto be the first \"user\" role message in the conversation.","ref":"Store.Project.Conversation.html#question/1"},{"type":"function","title":"Store.Project.Conversation.read/1","doc":"Reads the conversation from the store. Returns a tuple with the timestamp and\nthe messages in the conversation.","ref":"Store.Project.Conversation.html#read/1"},{"type":"type","title":"Store.Project.Conversation.t/0","doc":"","ref":"Store.Project.Conversation.html#t:t/0"},{"type":"function","title":"Store.Project.Conversation.timestamp/1","doc":"Returns the timestamp of the conversation. If the conversation has not yet\nbeen saved to the store, returns 0.","ref":"Store.Project.Conversation.html#timestamp/1"},{"type":"function","title":"Store.Project.Conversation.write/2","doc":"Saves the conversation in the store. The conversation's timestamp is updated\nto the current time.","ref":"Store.Project.Conversation.html#write/2"},{"type":"module","title":"Store.Project.Entry","doc":"","ref":"Store.Project.Entry.html"},{"type":"function","title":"Store.Project.Entry.create/1","doc":"","ref":"Store.Project.Entry.html#create/1"},{"type":"function","title":"Store.Project.Entry.delete/1","doc":"","ref":"Store.Project.Entry.html#delete/1"},{"type":"function","title":"Store.Project.Entry.embeddings_file_paths/1","doc":"","ref":"Store.Project.Entry.html#embeddings_file_paths/1"},{"type":"function","title":"Store.Project.Entry.exists_in_store?/1","doc":"","ref":"Store.Project.Entry.html#exists_in_store?/1"},{"type":"function","title":"Store.Project.Entry.has_embeddings?/1","doc":"","ref":"Store.Project.Entry.html#has_embeddings?/1"},{"type":"function","title":"Store.Project.Entry.has_metadata?/1","doc":"","ref":"Store.Project.Entry.html#has_metadata?/1"},{"type":"function","title":"Store.Project.Entry.has_outline?/1","doc":"","ref":"Store.Project.Entry.html#has_outline?/1"},{"type":"function","title":"Store.Project.Entry.has_summary?/1","doc":"","ref":"Store.Project.Entry.html#has_summary?/1"},{"type":"function","title":"Store.Project.Entry.hash_is_current?/1","doc":"","ref":"Store.Project.Entry.html#hash_is_current?/1"},{"type":"function","title":"Store.Project.Entry.is_incomplete?/1","doc":"","ref":"Store.Project.Entry.html#is_incomplete?/1"},{"type":"function","title":"Store.Project.Entry.is_stale?/1","doc":"","ref":"Store.Project.Entry.html#is_stale?/1"},{"type":"function","title":"Store.Project.Entry.metadata_file_path/1","doc":"","ref":"Store.Project.Entry.html#metadata_file_path/1"},{"type":"function","title":"Store.Project.Entry.new_from_entry_path/2","doc":"","ref":"Store.Project.Entry.html#new_from_entry_path/2"},{"type":"function","title":"Store.Project.Entry.new_from_file_path/2","doc":"","ref":"Store.Project.Entry.html#new_from_file_path/2"},{"type":"function","title":"Store.Project.Entry.outline_file_path/1","doc":"","ref":"Store.Project.Entry.html#outline_file_path/1"},{"type":"function","title":"Store.Project.Entry.read/1","doc":"","ref":"Store.Project.Entry.html#read/1"},{"type":"function","title":"Store.Project.Entry.read_embeddings/1","doc":"","ref":"Store.Project.Entry.html#read_embeddings/1"},{"type":"function","title":"Store.Project.Entry.read_metadata/1","doc":"","ref":"Store.Project.Entry.html#read_metadata/1"},{"type":"function","title":"Store.Project.Entry.read_outline/1","doc":"","ref":"Store.Project.Entry.html#read_outline/1"},{"type":"function","title":"Store.Project.Entry.read_source_file/1","doc":"","ref":"Store.Project.Entry.html#read_source_file/1"},{"type":"function","title":"Store.Project.Entry.read_summary/1","doc":"","ref":"Store.Project.Entry.html#read_summary/1"},{"type":"function","title":"Store.Project.Entry.save/4","doc":"","ref":"Store.Project.Entry.html#save/4"},{"type":"function","title":"Store.Project.Entry.save_embeddings/2","doc":"","ref":"Store.Project.Entry.html#save_embeddings/2"},{"type":"function","title":"Store.Project.Entry.save_metadata/1","doc":"","ref":"Store.Project.Entry.html#save_metadata/1"},{"type":"function","title":"Store.Project.Entry.save_outline/2","doc":"","ref":"Store.Project.Entry.html#save_outline/2"},{"type":"function","title":"Store.Project.Entry.save_summary/2","doc":"","ref":"Store.Project.Entry.html#save_summary/2"},{"type":"function","title":"Store.Project.Entry.summary_file_path/1","doc":"","ref":"Store.Project.Entry.html#summary_file_path/1"},{"type":"type","title":"Store.Project.Entry.t/0","doc":"","ref":"Store.Project.Entry.html#t:t/0"},{"type":"module","title":"Store.Project.Entry.Embeddings","doc":"","ref":"Store.Project.Entry.Embeddings.html"},{"type":"module","title":"Store.Project.Entry.Metadata","doc":"","ref":"Store.Project.Entry.Metadata.html"},{"type":"module","title":"Store.Project.Entry.Outline","doc":"","ref":"Store.Project.Entry.Outline.html"},{"type":"module","title":"Store.Project.Entry.Summary","doc":"","ref":"Store.Project.Entry.Summary.html"},{"type":"behaviour","title":"Store.Project.EntryFile","doc":"","ref":"Store.Project.EntryFile.html"},{"type":"callback","title":"Store.Project.EntryFile.exists?/1","doc":"","ref":"Store.Project.EntryFile.html#c:exists?/1"},{"type":"callback","title":"Store.Project.EntryFile.new/2","doc":"","ref":"Store.Project.EntryFile.html#c:new/2"},{"type":"callback","title":"Store.Project.EntryFile.read/1","doc":"","ref":"Store.Project.EntryFile.html#c:read/1"},{"type":"callback","title":"Store.Project.EntryFile.store_path/1","doc":"","ref":"Store.Project.EntryFile.html#c:store_path/1"},{"type":"callback","title":"Store.Project.EntryFile.write/2","doc":"","ref":"Store.Project.EntryFile.html#c:write/2"},{"type":"module","title":"Store.Project.Notes","doc":"","ref":"Store.Project.Notes.html"},{"type":"function","title":"Store.Project.Notes.file_path/0","doc":"","ref":"Store.Project.Notes.html#file_path/0"},{"type":"function","title":"Store.Project.Notes.read/0","doc":"","ref":"Store.Project.Notes.html#read/0"},{"type":"function","title":"Store.Project.Notes.reset/0","doc":"","ref":"Store.Project.Notes.html#reset/0"},{"type":"function","title":"Store.Project.Notes.write/1","doc":"","ref":"Store.Project.Notes.html#write/1"},{"type":"module","title":"Timed","doc":"","ref":"Timed.html"},{"type":"function","title":"Timed.timed/2","doc":"","ref":"Timed.html#timed/2"},{"type":"module","title":"UI","doc":"","ref":"UI.html"},{"type":"function","title":"UI.async_stream/4","doc":"","ref":"UI.html#async_stream/4"},{"type":"function","title":"UI.begin_step/2","doc":"","ref":"UI.html#begin_step/2"},{"type":"function","title":"UI.colorize?/0","doc":"","ref":"UI.html#colorize?/0"},{"type":"function","title":"UI.confirm/1","doc":"","ref":"UI.html#confirm/1"},{"type":"function","title":"UI.confirm/2","doc":"","ref":"UI.html#confirm/2"},{"type":"function","title":"UI.debug/1","doc":"","ref":"UI.html#debug/1"},{"type":"function","title":"UI.debug/2","doc":"","ref":"UI.html#debug/2"},{"type":"function","title":"UI.end_step/2","doc":"","ref":"UI.html#end_step/2"},{"type":"function","title":"UI.error/1","doc":"","ref":"UI.html#error/1"},{"type":"function","title":"UI.error/2","doc":"","ref":"UI.html#error/2"},{"type":"function","title":"UI.fatal/1","doc":"","ref":"UI.html#fatal/1"},{"type":"function","title":"UI.fatal/2","doc":"","ref":"UI.html#fatal/2"},{"type":"function","title":"UI.flush/0","doc":"","ref":"UI.html#flush/0"},{"type":"function","title":"UI.info/1","doc":"","ref":"UI.html#info/1"},{"type":"function","title":"UI.info/2","doc":"","ref":"UI.html#info/2"},{"type":"function","title":"UI.is_tty?/0","doc":"","ref":"UI.html#is_tty?/0"},{"type":"function","title":"UI.italicize/1","doc":"","ref":"UI.html#italicize/1"},{"type":"function","title":"UI.log_usage/2","doc":"","ref":"UI.html#log_usage/2"},{"type":"function","title":"UI.printf_debug/1","doc":"","ref":"UI.html#printf_debug/1"},{"type":"function","title":"UI.progress_bar_start/3","doc":"","ref":"UI.html#progress_bar_start/3"},{"type":"function","title":"UI.progress_bar_update/1","doc":"","ref":"UI.html#progress_bar_update/1"},{"type":"function","title":"UI.quiet?/0","doc":"","ref":"UI.html#quiet?/0"},{"type":"function","title":"UI.report_step/1","doc":"","ref":"UI.html#report_step/1"},{"type":"function","title":"UI.report_step/2","doc":"","ref":"UI.html#report_step/2"},{"type":"function","title":"UI.say/1","doc":"","ref":"UI.html#say/1"},{"type":"function","title":"UI.spin/2","doc":"","ref":"UI.html#spin/2"},{"type":"function","title":"UI.warn/1","doc":"","ref":"UI.html#warn/1"},{"type":"function","title":"UI.warn/2","doc":"","ref":"UI.html#warn/2"},{"type":"function","title":"UI.warning_banner/1","doc":"","ref":"UI.html#warning_banner/1"},{"type":"module","title":"UI.Formatter","doc":"Formats output strings using an external command specified by the\n`FNORD_FORMATTER` environment variable. If unset or empty, returns the\noriginal string. On command failure or non-zero exit code, logs a warning and\nreturns the original string.\n\nNote: We invoke the formatter via `shell -c`, which may be subject to shell\ninjection if `FNORD_FORMATTER` contains malicious content. This CLI is\nintended for trusted environments, so this risk is accepted.","ref":"UI.Formatter.html"},{"type":"function","title":"UI.Formatter.format_output/1","doc":"","ref":"UI.Formatter.html#format_output/1"},{"type":"module","title":"Util","doc":"","ref":"Util.html"},{"type":"type","title":"Util.async_cb/0","doc":"","ref":"Util.html#t:async_cb/0"},{"type":"function","title":"Util.async_filter/2","doc":"Filters an enumerable asynchronously using the provided function. The\nfunction should return `true` for items to keep and `false` for items to\ndiscard. The result is a stream of items that passed the filter.","ref":"Util.html#async_filter/2"},{"type":"type","title":"Util.async_item/0","doc":"","ref":"Util.html#t:async_item/0"},{"type":"function","title":"Util.async_stream/3","doc":"Convenience wrapper for `Task.async_stream/3` with the default options for\nconcurrency and timeout set to `Application.get_env(:fnord, :workers)` and\n`:infinity`, respectively.","ref":"Util.html#async_stream/3"},{"type":"function","title":"Util.diff_files/2","doc":"Compares two files using the `diff` command and returns the output.\nIf the files are identical, it returns `{:ok, \"No changes detected.\"}`.\nIf there are differences, it returns `{:ok, output}` with the diff output.\nIf an error occurs, it returns `{:error, output}` with the error message.","ref":"Util.html#diff_files/2"},{"type":"function","title":"Util.expand_path/2","doc":"Expands a given path to its absolute form, expanding `.` and `..`. If a root\ndirectory is provided, it will expand the path relative to that root. If no\nroot is provided, it will expand the path relative to the current working\ndirectory. The root directory is expanded first, if provided (see\n`Path.expand/2`).","ref":"Util.html#expand_path/2"},{"type":"function","title":"Util.find_file/1","doc":"Shortcut for `find_file_within_root(path,  )`. Returns `{:error,\n:enoent}` if the current working directory cannot be determined.","ref":"Util.html#find_file/1"},{"type":"function","title":"Util.find_file_within_root/2","doc":"Finds a file within the specified root directory. It resolves symlinks for\nboth the file path and the root directory. If the resolved file path is\nwithin the root directory, it returns `{:ok, resolved_path}`, otherwise\n`{:error, :enoent}`.","ref":"Util.html#find_file_within_root/2"},{"type":"function","title":"Util.format_number/1","doc":"","ref":"Util.html#format_number/1"},{"type":"function","title":"Util.get_latest_version/0","doc":"","ref":"Util.html#get_latest_version/0"},{"type":"function","title":"Util.get_running_version/0","doc":"","ref":"Util.html#get_running_version/0"},{"type":"function","title":"Util.int_damnit/1","doc":"Converts a value to an integer, raising an `ArgumentError` if the value\ncannot be parsed as an integer. Accepts both binary strings and integers.","ref":"Util.html#int_damnit/1"},{"type":"function","title":"Util.numbered_lines/3","doc":"Adds line numbers to each line of the input text, separated by a specified\nseparator (default is \"|\"). The numbering starts from 1, or `start_index`, if\nset.","ref":"Util.html#numbered_lines/3"},{"type":"function","title":"Util.parse_int/1","doc":"Parses a binary string into an integer, returning `{:ok, int}` if successful,\nor `{:error, :invalid_integer}` if the string cannot be parsed as an integer.\nAccepts both binary strings and integers.","ref":"Util.html#parse_int/1"},{"type":"function","title":"Util.path_within_root?/2","doc":"Returns `true` if the given path is within the specified root directory,\n`false` otherwise. Expands both the path and the root to their absolute\nforms, resolving symlinks, before performing the check.","ref":"Util.html#path_within_root?/2"},{"type":"function","title":"Util.resolve_symlink/2","doc":"Resolves a symlink to its final target. If the path is relative, it will\nfirst be expanded relative to the given root. If root is not provided, it\nwill expand relative to the current working directory. If a circular symlink\nis detected, it returns `{:error, :circular_symlink}`. Otherwise, it returns\nthe absolute, resolved path or the error tuple originating from\n`File.lstat/1`.","ref":"Util.html#resolve_symlink/2"},{"type":"function","title":"Util.string_keys_to_atoms/1","doc":"Converts all string keys in a map to atoms, recursively.","ref":"Util.html#string_keys_to_atoms/1"},{"type":"function","title":"Util.ucfirst/1","doc":"Capitalizes the first letter of each word in the input string.","ref":"Util.html#ucfirst/1"},{"type":"extras","title":"Fnord","doc":"# Fnord\n\n[![Tests | Dialyzer](https://github.com/sysread/fnord/actions/workflows/run-tests.yml/badge.svg)](https://github.com/sysread/fnord/actions/workflows/run-tests.yml)\n\n- [Description](#description)\n- [Features](#features)\n- [Installation](#installation)\n- [Getting Started](#getting-started)\n- [Tool usage](#tool-usage)\n- [User integrations](#user-integrations)\n- [Writing code (EXPERIMENTAL)](#writing-code)\n- [Copyright and License](#copyright-and-license)","ref":"readme.html"},{"type":"extras","title":"Description - Fnord","doc":"`fnord` is a command line tool that uses multiple LLM-powered agents and tools to provide a conversational interface to your codebase, notes, and other (non-binary) files.\n\nIt can be used to generate on-demand tutorials, playbooks, and documentation for your project, as well as to search for examples, explanations, and solutions to problems in your codebase.","ref":"readme.html#description"},{"type":"extras","title":"Why fnord? - Fnord","doc":"AI-powered tools are limited by to the data built into their training data. **RAG (Retrieval-Augmented Generation)** using tool calls can supplement the training data with information, such as your code base, to provide more accurate and relevant answers to your questions.\n\nBut even with RAG, the AI still runs up against the **context window**. This is the conversational \"memory\" of the AI, often making use of an \"attention mechanism\" to keep it focused on the current instructions, but causing it to lose track of details earlier in the conversation.\n\nIf you've ever pasted multiple files into ChatGPT or worked with it iteratively on a piece of code, you've probably seen this in action. It may forget constraints you defined earlier in the conversation or hallucinate entities and functions that don't exist in any of the files you've shown it.\n\n`fnord` attempts to mitigate this with cleverly designed tool calls that allow the LLM to ask _other_ agents to perform tasks on its behalf. For example, it can generate a prompt to ask another agent to read through a file and retrieve specific details it needs, like a single function definition, the declaration of an interface, or whether a specific function behaves in a certain way. This keeps the entire file out of the \"coordinating\" agent's context window while still allowing it to use the information in the file to generate a response. This allows `fnord` to conduct more complex research across many files and directories without losing track of the details it needs to provide accurate answers.","ref":"readme.html#why-fnord"},{"type":"extras","title":"Features - Fnord","doc":"- Semantic search\n- On-demand explanations, documentation, and tutorials\n- Git archaeology\n- Learns about your project(s) over time\n- Improves its research capabilities with each interaction\n- User integrations","ref":"readme.html#features"},{"type":"extras","title":"Installation - Fnord","doc":"Fnord is written in [Elixir](https://elixir-lang.org/) and is distributed as an `escript`.\n\n- **Install [elixir](https://elixir-lang.org/)**\n```bash\n# MacOS\nbrew install elixir\n\n# Debian-based\nsudo apt-get install elixir\n```\n\n- **Add the `escript` path to your shell's PATH**\n```bash\necho 'export PATH=\"$HOME/.mix/escripts:$PATH\"' >> ~/.bashrc\nsource ~/.bashrc\n```\n\n- **Install `fnord`**\n```bash\nmix escript.install github sysread/fnord\n```\n\n- **Set `OPENAI_API_KEY` in your shell environment**\n\nSet this in your shell environment to the OpenAI project key you wish to use for this tool.\nYou can create a new project and get a key [here](https://platform.openai.com/api-keys).\n\n\n- **Optional: Install `ripgrep`**\n\n`fnord` includes tooling for the LLM to use the `ripgrep` tool in addition to semantic search.\nThis enables the LLM to answer questions about your code base, even if the project has not been indexed yet (with the caveat that the results will be less context-aware).\n\n\n- **Optional: Install a markdown viewer**\n\nMarkdown seems to be the language of choice for LLMs, so installing something like `gum` or `glow` to pipe output to will make the output more readable.\nYou can make your preferred formatter persistent by setting the `FNORD_FORMATTER` environment variable in your shell.\n\n```bash\nexport FNORD_FORMATTER=\"gum format\"\n```","ref":"readme.html#installation"},{"type":"extras","title":"Getting Started - Fnord","doc":"For the purposes of this guide, we will assume that `fnord` is installed and we are using it to interact with your project, `blarg`, which is located at `$HOME/dev/blarg`.","ref":"readme.html#getting-started"},{"type":"extras","title":"Index your project - Fnord","doc":"The first step is to index your project to make it searchable with `fnord`'s semantic search capabilities.\nThe first time you index your project may take a while, especially if there are a lot of files.\n`fnord` respects `.gitignore`, but you may also wish to exclude certain paths or globs from indexing (e.g., `-x 'node_modules'`).\n\n```bash\nfnord index --project blarg --dir $HOME/dev/blarg --exclude 'node_modules'\n```\n\nIf you cancel partway-through (for example, with `Ctrl-C`), you can resume indexing by running the same command again.\n\nYou must re-index your project to reflect changes in the code base, new files, deleted files, or to change the directory or exclusions.\nThis is done by running the same command again.\n\n`fnord` stores its index in `$HOME/.fnord/$project`.\n\nAlthough indexing provides full semantic search capabilities and richer results, `fnord` also supports ad-hoc querying on unindexed projects via directory metadata and `ripgrep` fallback, allowing quicker experimentation without full indexing.","ref":"readme.html#index-your-project"},{"type":"extras","title":"Prime the knowledge base - Fnord","doc":"`fnord` can generate an initial set of learnings about your project to prime its knowledge base.\n\n```bash\nfnord prime --project blarg\n```","ref":"readme.html#prime-the-knowledge-base"},{"type":"extras","title":"Configuration - Fnord","doc":"You can view and edit the configuration for your project with the `fnord config` command.\n\n```bash\nfnord config list --project blarg\nfnord config set --project blarg --root $HOME/dev/blarg --exclude 'node_modules' --exclude 'vendor'\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Search your code base - Fnord","doc":"`fnord`'s semantic search is powered by embeddings generated by OpenAI's `text-embedding-3-large` model. The indexing process does a lot more than simply generate embeddings for the contents of your files. It also generates summary documentation for each file as well as an index of all functions, entities, and symbols in each file to enhance semantic matches for common questions and symbols.\n\n```bash\nfnord search --project blarg --query \"callers of some_function\"\nfnord search --project blarg --query \"some_function definition\"\nfnord search --project blarg --query \"unit tests for some_function\"\n```\n\nThe summaries generated by the indexing process can also be included in the search results with the `--detail` flag.\n\n```bash\nfnord search --project blarg --query \"some_function declaration\" --detail | glow\n```\n\nIf you would like to see more information about a single file, you can use the `summary` command.\n\n```bash\nfnord summary --project blarg --file \"path/to/some_module.ext\" | glow\n```","ref":"readme.html#search-your-code-base"},{"type":"extras","title":"Search behavior and fallbacks - Fnord","doc":"`fnord` uses semantic search by default when a project has been indexed. If semantic search is unavailable (because the project is unindexed or the index is missing):\n\n- Semantic search will be disabled with a warning.\n- If `ripgrep` is installed and in your PATH, `fnord` will automatically fall back to ripgrep for basic text-based file search.\n- If ripgrep is not available, you will see a warning indicating limited search capability.\n- This fallback behavior lets you query projects immediately without waiting for a full index, providing fast albeit less context-aware results.","ref":"readme.html#search-behavior-and-fallbacks"},{"type":"extras","title":"Generate answers on-demand - Fnord","doc":"`fnord` uses a combination of LLM-powered agents and tool calls to research your question within your project, including access to semantic search and git tools (read only!).\n\nAs it conducts its investigation, you will see some of the research steps reported back to you in real-time. These are printed to `STDERR` so they will not interfere with redirected output. If you wish to see more of this, set `LOGGER_LEVEL=debug` in your shell.\n\n```bash\nfnord ask --project blarg --question \"Where is the unit test for some_function?\"\nfnord ask --project blarg --question \"Find all callers of some_function\"\nfnord ask --project blarg --question \"Is there a function or method that does X?\"\nfnord ask --project blarg --question \"How do I add a new X implementation?\"\n```\n\n#### Asking questions without prior indexing\n\nYou can now use `fnord ask` on projects that have **not yet been indexed** or where the project index is unavailable.\n\n- If the project is already created in `fnord` but not indexed, semantic search will be disabled, and `ripgrep` fallback will be used if available.\n- If the project does **not exist in fnord yet**, you can provide the project's root directory with the `--directory` (or `-d`) option when running `fnord ask`.\n- This will automatically create the project metadata on demand and allow you to query the project files without requiring a full index upfront.\n\nExample usage:\n\n```bash\n# Ask a question about a project without an index by specifying the source directory\nfnord ask --project blarg --directory $HOME/dev/blarg --question \"Where is the unit test for some_function?\"\n\n# Continue to specify the directory if the project has not been indexed or created yet\nfnord ask --project new_project --directory /path/to/new_project --question \"Explain the main workflow\"\n```\n\nNote: If semantic search is unavailable and `ripgrep` is not installed, you will receive a warning and limited search capability. To get full semantic search power, please index your project using the `fnord index` command.\n\n#### Improve research quality\n\nBy default, `ask` performs a single round of research (multiple tool calls per round notwithstanding).\nYou can increase the number of rounds with the `--rounds` option.\nIncreasing the number of rounds will increase the time it takes to generate a response, but can drastically improve the quality and thoroughness of the response, especially in large code bases or code bases containing multiple apps.\n\n```bash\nfnord ask --project blarg --question \"Please confirm that all information in the README is up-to-date and correct. Identify user-facing functionality that is not well-documented.\" --rounds 3\n```\n\n#### Continuing a conversation\n\nConversations (the transcript of messages between the LLM and the application) are saved for future reference and continuation. After each response, you will see a message like:\n```\nConversation saved with ID: c81928aa-6ab2-4346-9b2a-0edce6a639f0\n```\n\nIf desired, you can use that ID to continue the conversation with `--conversation`.\n\n```bash\nfnord ask --project blarg --conversation c81928aa-6ab2-4346-9b2a-0edce6a639f0 --question \"Is some_function still used?\"\n```\n\n...or can continue the _most recently saved conversation_ with `--follow`.\n\n```bash\nfnord ask --project blarg --follow --question \"Is some_function still used?\"\n```\n\n\nList conversations with the `conversations` command.\n\n```bash\nfnord conversations --project blarg\n```\n\nPrune conversations older than a certain number of days with the `--prune` option.\n\n```bash\n# Prune conversations older than 30 days\nfnord conversations --project blarg --prune 30\n```\n\n#### Replaying a conversation\n\nYou can also `replay` a conversation, replicating the output of the original question, research steps, and response.\n\n```bash\nfnord replay --project blarg --conversation c81928aa-6ab2-4346-9b2a-0edce6a639f0 | glow\n```\n\nAs it learns more about your project, `fnord` will be able to answer more complex questions with less research.","ref":"readme.html#generate-answers-on-demand"},{"type":"extras","title":"Learning over time - Fnord","doc":"`fnord` learns about your project over time by saving facts and inferences it makes about the project while researching your questions. These facts and inferences are saved and made\nsearchable in the project's data in the `$HOME/.fnord` directory.\n\nYou can view the facts learned thus far, organized by topic, with the `notes` command.\n\n```bash\nfnord notes --project blarg | glow\n```\n\nOver time, these can become quite extensive, redundant, and stale over time as your code base evolves.\n\n`fnord` knows how to \"prime the pump\" for its learning process with an initial set of learnings.\n\n```bash\nfnord ask --project blarg --question \"Prime your research notes and report your findings\"\n```","ref":"readme.html#learning-over-time"},{"type":"extras","title":"Upgrades - Fnord","doc":"`fnord` is under active development and new features are added regularly. To upgrade to the latest version, simply run:\n\n```bash\nfnord upgrade\n```\n\nNote that this is just a shortcut for:\n\n```bash\nmix escript.install github sysread/fnord\n```","ref":"readme.html#upgrades"},{"type":"extras","title":"Other commands - Fnord","doc":"- List projects: `fnord projects`\n- List files in a project: `fnord files --project foo`\n- Delete a project: `fnord torch --project foo`","ref":"readme.html#other-commands"},{"type":"extras","title":"Tool usage - Fnord","doc":"All of the tool calls available to `fnord` are available for external use via the `tool` subcommand.\n\n```bash\n# List available tools\nfnord help tool\n\n# Get help for a specific tool\nfnord tool --tool file_search_tool --help\n\n# Call the tool\nfnord tool --tool file_search_tool --project blarg --query \"some_function definition\"\nfnord tool --tool file_info_tool --project blarg --file \"path/to/some_module.ext\" --question \"What public functions are defined in this file?\"\n```","ref":"readme.html#tool-usage"},{"type":"extras","title":"User integrations - Fnord","doc":"Users can create their own integrations, called frobs, that `fnord` can use as a tool call while researching.\nJust like built-in tools, these are usable through the `fnord tool` subcommand.\n\n```bash\n# Create a new integration\nfnord frobs create --name my_frob\n\n# Validate the frob\nfnord frobs check --name my_frob\n\n# List frobs\nfnord frobs list\n\n# List frobs that are registered for a project\nfnord frobs list --project blarg\n```\n\nFrobs are stored in `$HOME/fnord/tools` and are comprised of the following files:\n- `my_frob/registry.json` - a JSON file that identifies the projects for which the frob is available\n- `my_frob/spec.json` - a JSON file describing the frob's calling semantics in [OpenAI's function spec format](https://platform.openai.com/docs/guides/function-calling?api-mode=responses#defining-functions)\n- `my_frob/main` - a script or binary that performs the requested task\n\nMake your tool available to your projects: edit the `registry.json` file created when you ran `fnord frobs create` to include the project name(s) for which you want the frob to be available.\n\n```json\n{\n  // When true, the frob is available to all projects and the \"projects\" field is ignored.\n  \"global\": true,\n\n  // An array of project names for which fnord should make the frob available. Superseded by the \"global\" field when set to true.\n  \"projects\": [\"blarg\", \"some_other_project\"]\n}\n```\n\nImplementing the frob: the `main` file is a script or binary that implements the frob. `fnord` passes information to the frob via shell environment variables:\n\n- `FNORD_PROJECT`: The name of the currently selected project\n- `FNORD_CONFIG`: The project configuration from `$HOME/.fnord/settings.json` as a single JSON object\n- `FNORD_ARGS_JSON`: JSON object of LLM-provided arguments\n\nTesting your frob: if you prefix your `fnord ask` query with `testing:`, you can ask the LLM to test your frob to confirm it is working as expected.\n\n```bash\nfnord ask -p blarg -q \"testing: please confirm that the 'my_frob' tool is available to you\"\nfnord ask -p blarg -q \"testing: please make a call to 'my_frob' with the arguments 'foo' and 'bar' and report the results\"\n```","ref":"readme.html#user-integrations"},{"type":"extras","title":"Writing code - Fnord","doc":"Fnord can (optionally) automate code changes in your project using the `ask` command with the `--edit` flag.\n\n**HIGHLY EXPERIMENTAL!**\n- Use `--edit` with extreme caution.\n- AI-driven code modification is unsafe, may corrupt or break files, and must always be manually reviewed.","ref":"readme.html#writing-code"},{"type":"extras","title":"How it works - Fnord","doc":"The LLM has access to several tools that allow it to modify code within the project directory and perform basic file management tasks.\nIt *cannot* perform write operations with `git` or act on files outside of the project's root and `/tmp`.\n\n```bash\nfnord ask --project myproj --edit --question \"Add a docstring to foo/thing.ex\"\n```\n\nCode modification by an LLM is *unreliable* and is not safe for unsupervised use.\nThe AI may behave unpredictably.","ref":"readme.html#how-it-works"},{"type":"extras","title":"Copyright and License - Fnord","doc":"This software is copyright (c) 2025 by Jeff Ober.\n\nThis is free software; you can redistribute it and/or modify it under the MIT License.","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}